local G, F, C, L = unpack(select(2,...))
local _
local function TestFunc()

--detailsǳչhttps://wago.io/uq0Uox6Ta/3
if _G.NickTag then
    local cyrillic = "??????????????ѧҧӧԧէ֧ا٧ڧۧܧݧާߧ??????????????ѧҧӧԧէ֧קا٧ڧۧܧݧާߧৱ᧲⧳㧴䧵姶槷秸觹駺ꧻ맼짽"
    local latin = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
    local chinese = "?????????????????????????????????????????????????????????????????????????????????????????????????????????????"
    
    local alphabet = {
        ["cyrillic"] = {},
        ["latin"] = {},
        ["chinese"] = {},
    }
    
    for letter in cyrillic:gmatch(".") do
        alphabet["cyrillic"][letter] = true
    end
    for letter in latin:gmatch(".") do
        alphabet["latin"][letter] = true
    end
    for letter in chinese:gmatch(".") do
        alphabet["chinese"][letter] = true
    end
    
    --> trim from from http://lua-users.org/wiki/StringTrim
    local function trim (s)
        local from = s:match"^%s*()"
        return from > #s and "" or s:match(".*%S", from)
    end
    --
    local titlecase = function (first, rest)
        return first:upper()..rest:lower()
    end
    
    --> we need to keep game smooth checking and formating nicknames.
    --> SetNickname and names comming from other player need to be check.
    function NickTag:CheckName (name)
        --> as nicktag only work internally in the guild, we think that is not necessary a work filter to avoid people using bad language.
        
        if (type (name) ~= "string") then
            return false, LibStub ("AceLocale-3.0"):GetLocale ("NickTag-1.0")["STRING_ERROR_4"] --> error 4 = name isn't a valid string
        end
        
        name = trim (name)
        
        --which alphabet to use
        local alphabetToUse = "latin"
        local firstLetter = name:match("^.")
        local maxLength = 20
        
        if (alphabet["cyrillic"][firstLetter]) then
            --reserve cyrillic only to clients running ruRU
            if (GetLocale() == "ruRU") then
                alphabetToUse = "cyrillic"
                maxLength = 40 --cyrillic uses two bytes
            else
                alphabetToUse = "latin"
            end
            
        elseif (alphabet["chinese"][firstLetter]) then
            if (GetLocale() == "zhCN" or GetLocale() == "zhTW") then
                alphabetToUse = "chinese"
                maxLength = 80 --chinese uses 4 bytes
            else
                alphabetToUse = "latin"
            end
        end
        
        return true
    end
    
end

end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)