﻿local G, F, C, L = unpack(select(2,...))
local _
local function TestFunc()
if AddUIDB.unitf ==  false  then return end

local function textUpdate(bar)
local textType = GetCVar("statusTextDisplay")
local frame = bar:GetParent()
if bar.StatusBar then bar=bar.StatusBar end
local value = bar:GetValue()
local _, max = bar:GetMinMaxValues()
if bar.pctText then
bar.pctText:SetText((textType ~= "NUMERIC" or value == 0) and "" or tostring(math.ceil((value / max) * 100)) .. "%")
end
if bar.TextString and frame.addPctText and textType == "NUMERIC" then
bar.TextString:SetText(value == 0 and "" or value)
end
end 

local colorbyclass = true	--头像职业染色
local function colorHPBar(bar, unit)
	if bar and not bar.lockValues and unit == bar.unit then
		local r, g, b
		local min, max = bar:GetMinMaxValues()
		local value = bar:GetValue()
		if max > min then
			value = (value - min) / (max - min)
		else
			value = 0
		end
		
		if value > 0.5 then
			r, g, b = 2*(1-value), 1, 0
		else
			r, g, b = 1, 2*value, 0
		end
		if not bar.disconnected and not bar.lockColor then
			if colorbyclass and UnitIsPlayer(unit) and UnitClass(unit) then
				local color = RAID_CLASS_COLORS[select(2, UnitClass(unit))]
				bar:SetStatusBarColor(color.r, color.g, color.b)
			--else
			--	bar:SetStatusBarColor(r, g, b)
			end
		end
		if bar.pctText then bar.pctText:SetTextColor(r, g, b) end
	end
end

hooksecurefunc("TextStatusBar_UpdateTextString", textUpdate)
hooksecurefunc("UnitFrameHealthBar_Update", colorHPBar)
hooksecurefunc("HealthBar_OnValueChanged", function(self) colorHPBar(self, self.unit) end)

function CreateBarPctText(frame, ap, rp, x, y, font, manabar)
	local bar = ( manabar and frame.manabar ) or ( not manabar and frame.healthbar )
	if bar then
		if bar.pctText then
			bar.pctText:ClearAllPoints()
			bar.pctText:SetPoint(ap, bar, rp, x, y)
		else
			font = font or "NumberFontNormal"
			bar.pctText = frame:CreateFontString(nil, "OVERLAY", font)
			bar.pctText:SetPoint(ap, bar, rp, x, y)
			frame.addPctText = true
		end
	end
end

-------------------
------ 血量百分比 -------
---------------------
if not AddUIDB.myframestyle then
CreateBarPctText(PlayerFrame, "LEFT", "top", 63, -15, "NumberFontNormalLarge")-----自身头像百分比位置，系统自带改25.30
end
CreateBarPctText(PetFrame, "LEFT", "top", 35, -5)-----宠物栏头像百分比位置
PetFrameHealthBarText:SetTextHeight(9)
PetFrameManaBarText:SetTextHeight(9)
	
for i = 1, 4 do
	local frame = "PartyMemberFrame"..i
	CreateBarPctText(_G[frame], "LEFT", "RIGHT", 6, 0)
	_G[frame.."HealthBarText"]:SetTextHeight(9)
	_G[frame.."ManaBarText"]:SetTextHeight(9)
end

CreateBarPctText(TargetFrame, "RIGHT", "top", -60, -15, "NumberFontNormalLarge")-----目标头像百分比位置,系统自带改-25.30
CreateBarPctText(TargetFrameToT, "BOTTOMLEFT", "TOPRIGHT", 2, -10)------目标的目标百分比位置
CreateBarPctText(FocusFrame, "RIGHT", "top", -65, -15, "NumberFontNormalLarge")-----焦点头像百分比位置
CreateBarPctText(FocusFrameToT, "BOTTOMLEFT", "TOP", 28, -10)

for i = 1, MAX_BOSS_FRAMES do
	local bossFrame = _G["Boss"..i.."TargetFrame"]
	CreateBarPctText(bossFrame, "RIGHT", "LEFT", 0, 0, "NumberFontNormalLarge")
end



--------简化血量字体------------- 
local f=function(v)
   if (v >= 1e8) then
	  return ("%.2f亿"):format(v / 1e8)

   elseif(v >= 1e4) then 
	  return ('%.2f万'):format(v / 1e4) 
   else 
	  return ("%d"):format(v/1)
   end 
end 

hooksecurefunc("TextStatusBar_UpdateTextString",function(s) 
	if not GetCVarBool("statusTextPercentage") then 
		if 	s.TextString and s.currValue then 
			s.TextString:SetText(f(s:GetValue())) 
		end
		if 	s.RightText and s.currValue then
			s.RightText:SetText(f(s:GetValue()))
		end 
	end 
end)

end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)